/* Fill-in information from Blynk Device Info here */
#define BLYNK_TEMPLATE_ID "TMPLQ1e7po8x"
#define BLYNK_DEVICE_NAME "IOT Final Project"
#define BLYNK_AUTH_TOKEN "DiAiPYfpxmz8O5Z8gTo87LnT__zYjdwu"

/* Comment this out to disable prints and save space */
#define BLYNK_PRINT SerialUSB

#include <ESP8266_Lib.h>
#include <BlynkSimpleShieldEsp8266.h>
#include <Adafruit_CircuitPlayground.h>
#include <Servo.h>
#include <Wire.h>
#include <SPI.h>

const uint8_t spONE[]           PROGMEM = {0x66,0x4E,0xA8,0x7A,0x8D,0xED,0xC4,0xB5,0xCD,0x89,0xD4,0xBC,0xA2,0xDB,0xD1,0x27,0xBE,0x33,0x4C,0xD9,0x4F,0x9B,0x4D,0x57,0x8A,0x76,0xBE,0xF5,0xA9,0xAA,0x2E,0x4F,0xD5,0xCD,0xB7,0xD9,0x43,0x5B,0x87,0x13,0x4C,0x0D,0xA7,0x75,0xAB,0x7B,0x3E,0xE3,0x19,0x6F,0x7F,0xA7,0xA7,0xF9,0xD0,0x30,0x5B,0x1D,0x9E,0x9A,0x34,0x44,0xBC,0xB6,0x7D,0xFE,0x1F};
const uint8_t spTWO[]           PROGMEM = {0x06,0xB8,0x59,0x34,0x00,0x27,0xD6,0x38,0x60,0x58,0xD3,0x91,0x55,0x2D,0xAA,0x65,0x9D,0x4F,0xD1,0xB8,0x39,0x17,0x67,0xBF,0xC5,0xAE,0x5A,0x1D,0xB5,0x7A,0x06,0xF6,0xA9,0x7D,0x9D,0xD2,0x6C,0x55,0xA5,0x26,0x75,0xC9,0x9B,0xDF,0xFC,0x6E,0x0E,0x63,0x3A,0x34,0x70,0xAF,0x3E,0xFF,0x1F};
const uint8_t spTHREE[]         PROGMEM = {0xE8,0x2E,0x94,0x01,0x4D,0xBA,0x4A,0x40,0x03,0x16,0x68,0x69,0x36,0x1C,0xE9,0xBA,0xB8,0xE5,0x39,0x70,0x72,0x84,0xDB,0x51,0xA4,0xA8,0x4E,0xA3,0xC9,0x77,0xB1,0xCA,0xD6,0x52,0xA8,0x71,0xED,0x2A,0x7B,0x4B,0xA6,0xE0,0x37,0xB7,0x5A,0xDD,0x48,0x8E,0x94,0xF1,0x64,0xCE,0x6D,0x19,0x55,0x91,0xBC,0x6E,0xD7,0xAD,0x1E,0xF5,0xAA,0x77,0x7A,0xC6,0x70,0x22,0xCD,0xC7,0xF9,0x89,0xCF,0xFF,0x03};
const uint8_t spSTART[]         PROGMEM = {0x04,0xF8,0xC5,0x9C,0x03,0x1A,0xD0,0x80,0x04,0x38,0x00,0x06,0x58,0x22,0x7D,0x65,0x9D,0x87,0x8B,0x5B,0xD7,0x53,0x67,0x37,0x96,0x21,0x79,0x6F,0x7D,0xEB,0xD5,0x64,0xB7,0x92,0x43,0x9B,0xC7,0x50,0xDD,0x92,0x1D,0xF7,0x9E,0x53,0xDF,0xDD,0x59,0xCB,0x21,0xAD,0xF6,0x46,0xA0,0x08,0xE5,0x2E,0x22,0x1B,0x40,0x01,0xDD,0xB2,0x2A,0xE0,0xB7,0x0C,0x03,0x4C,0x9D,0x4A,0x80,0xEA,0x54,0xFE,0x1F};
const uint8_t spREADY[]         PROGMEM = {0x04,0x6A,0xD9,0x25,0x4A,0xE5,0xDB,0xD9,0x8D,0xB1,0xB2,0x45,0x9A,0xF6,0xD8,0x9F,0xAE,0x26,0xD7,0x30,0xED,0x72,0xDA,0x9E,0xCD,0x9C,0x6D,0xC9,0x6D,0x76,0xED,0xFA,0xE1,0x93,0x8D,0xAD,0x51,0x1F,0xC7,0xD8,0x13,0x8B,0x5A,0x3F,0x99,0x4B,0x39,0x7A,0x13,0xE2,0xE8,0x3B,0xF5,0xCA,0x77,0x7E,0xC2,0xDB,0x2B,0x8A,0xC7,0xD6,0xFA,0x7F};
int brightness = 0;  
int fadeAmount = 5;
Servo myServo;

// Your WiFi credentials.
// Set password to "" for open networks.
char ssid[] = "";
char pass[] = "";

// Hardware Serial on Mega, Leonardo, Micro...
#define EspSerial Serial1

// or Software Serial on Uno, Nano...
//#include <SoftwareSerial.h>
//SoftwareSerial EspSerial(2, 3); // RX, TX

// Your ESP8266 baud rate:
#define ESP8266_BAUD 115200

ESP8266 wifi(&EspSerial);

void setup()
{
  CircuitPlayground.begin();
  SerialUSB.begin(115200);
  EspSerial.begin(ESP8266_BAUD);
  Blynk.begin(BLYNK_AUTH_TOKEN, wifi, ssid, pass);
  Serial.begin(9600);
 
  myServo.attach(A2);
  pinMode(13, OUTPUT);
}

unsigned long lastSent;

void loop()
{
  Blynk.run();
  Blynk.virtualWrite(V5, "Welcome to the Untie Shoes app!");
  
  if (digitalRead(13) == HIGH) 
  {  
    if(millis() - lastSent >= 1000)
    {
      turnOffPixels();
      Blynk.virtualWrite(V6, "Currently being untied...");

      //Announcing countdown
      CircuitPlayground.speaker.say(spREADY);
      delay(500);
      CircuitPlayground.speaker.say(spTHREE);
      delay(500);
      CircuitPlayground.speaker.say(spTWO);
      delay(500);
      CircuitPlayground.speaker.say(spONE);
      delay(500);
      CircuitPlayground.speaker.say(spSTART);
      CircuitPlayground.speaker.end();

      //Moves the servo
      for(int i =0; i<= 180; i++)
      {
        myServo.write(i);
        delay(15);
      }
      digitalWrite(13, digitalRead(4));
      lastSent = millis();
    }
  }
  else
  {
    Blynk.virtualWrite(V6, "Time to untie shoes?");
    for (int i = 0; i < 10; i++)
    {
      CircuitPlayground.setPixelColor(i, 0,brightness,0);
      brightness = brightness + fadeAmount;
      
      if (brightness <= 0 || brightness >= 255)
      {
          fadeAmount = -fadeAmount;
      }
    }
  }
}

// Turning off all the pixels when app is activated
void turnOffPixels()
{
  for (int i = 0; i < 10; ++i) 
  {
    CircuitPlayground.setPixelColor(i, 0, 0, 0);
  }
}
